#include "handmade.h"
#include <windows.h>

struct Win32OffscreenBuffer {
    BITMAPINFO info;
    void *memory;
    int width;
    int height;
    int bytesPerPixel;
    int pitch;
};

struct Win32WindowDimensions {
    int width;
    int height;
};

struct Win32SoundOutput {
    int samplesPerSecond;
    int16 toneVolume;
    uint32 runningSampleIndex;
    int bytesPerSample;
    int secondaryBufferSize;
    real32 tSine;
    int safetyBytes;
};

struct Win32RecordedInput {
    int inputCount;
    GameInput *inputStream;
};

#define WIN32_STATE_FILE_NAME_LENGTH MAX_PATH
struct Win32ReplayBuffer {
    HANDLE memoryMap;
    HANDLE fileHandle;
    void *memoryBlock;
    char replayFilename[WIN32_STATE_FILE_NAME_LENGTH];
};

struct Win32State {
    HANDLE recordingHandle;
    uint32 inputRecordingIndex;

    HANDLE playbackHandle;
    uint32 inputPlayingIndex;

    uint64 gameMemoryTotalSize;
    void *gameMemoryBlock;
    Win32ReplayBuffer replayBuffers[4];

    char exeFilename[WIN32_STATE_FILE_NAME_LENGTH];
    char *onePastLastExeFilenameSlash;
};

struct Win32GameCode {
    HMODULE gameCodeLib;
    GameUpdateAndRenderFn *updateAndRender;
    GameGetSoundSamplesFn *getSoundSamples;
    bool isValid;
    FILETIME lastWriteTime;
};

